//	Copyright 2010 Ohtan's Design Corporation

//	 *****  *     * *******
//	*     * *     *    *   
//	*       *     *    *   
//	 *****  *******    *   
//	      * *     *    *  
//	*     * *     *    *   
//	 *****  *     *    *   

//
//  Aug. the 8th 2010
//  Crated by A.Ohta based on Electronic-craft Jack.
//  
//  SHT.c
//  SHT xZT[jbg쓮pCu[

// ===========================================================================
// =	CL^																 =
// ===========================================================================
//	002 2010.08.19(Thr)
//	EI/O_̏C
// ---------------------------------------------------------------------------
//	001 2010.08.08(Sun)
//	EVK\
// ===========================================================================

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C														 *
// ***************************************************************************
// ***************************************************************************
#include	<htc.h>

#include	"sht.h"
#include	"device.h"											//  I/O܂ Divice Ŝ̊ǗCN[hB

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

// ***************************************************************************
// ***************************************************************************
// *	\																 *
// ***************************************************************************
// ***************************************************************************


#define		SCK_H()		DevSigPutShtSCK_H()						//  The function of SHT-11  with SCK-LINE setting to "H" level.
#define		SCK_L()		DevSigPutShtSCK_L()						//  The function of SHT-11  with SCK-LINE setting to "L" level.

#define		DATA_H()	DevSigPutShtDATA_H()					//  The function of SHT-11  with DATA-LINE setting to "Hi-Z".
#define		DATA_L()	DevSigPutShtDATA_L()					//  The function of SHT-11  with DATA-LINE setting to "L" level.

//============================================================================
//	xZT[ւ̏ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	gprbg|[gPʂŏݒ肷B
//			|[g̕؂ւf[^ZbgAǂݍ݂́AO֐łPǗčsB
//============================================================================
void SHTInit(void) {

	SCK_L();
	DATA_L();
}

//============================================================================
//	SHT TSV[PX
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	xZT[@SHT-11 ƒʐMn߂ׂɕKvȓ]JñV[PXiMj
//			|[g̕؂ւf[^ZbgAǂݍ݂́AO֐łPǗčsB
//       _____         ________ 
// DATA:      |_______| 
//           ___     ___ 
// SCK : ___|   |___|   |______ 
//============================================================================
void SHTTSSeq(void) {
    DATA_H();
    SCK_H();

    DATA_L();
    SCK_L();

    SCK_H();
    DATA_H();

    SCK_L();
}

//============================================================================
//	PIC玼xZT[ւ̃f[^Miój
//----------------------------------------------------------------------------
//	́F	o̓f[^@F@ȂoCgf[^
//	óF	ACKԁ@F@ȂoCgf[^@(0:ACK,1:NOACK)
//----------------------------------------------------------------------------
//	lF	|[g̕؂ւf[^ZbgAǂݍ݂́AO֐łPǗčsB
//============================================================================
UB SHTWrite(UB dat) {
    UB i, rdat;

																// DATArbg̏o
    for(i = 0; i < 8; i++) {
        SCK_L();
        if(dat & 0x80) {										// MSB
																// "1"
            DATA_H();
        } else {
																// "0"
            DATA_L();
        }
        SCK_H();

        dat <<= 1;          									// ̃rbg
    }

    SCK_L();

																// ACKrbg̓
    DATA_H();              									    // ͂ɐ؂ւiHi-Zj

    SCK_H();													// edge
    if(SHT_PORT & (1<<bitDATA)) {								// read DATA
																// 1
        rdat = 1;												// NOACK
    } else {
																// 0
        rdat = 0;												// ACK
    }
    SCK_L();

    return rdat;
}

//============================================================================
//	PIC֎xZT[ւ̃f[^Míj
//----------------------------------------------------------------------------
//	́F	ACK@F@ȂoCgf[^
//	óF	dat@F@Mf[^ : ȂoCgf[^
//----------------------------------------------------------------------------
//	lF	|[g̕؂ւf[^ZbgAǂݍ݂́AO֐łPǗčsB
//============================================================================
UB SHTRead(UB ack) {
    UB i, dat;

    dat = 0;
    DATA_H();													// ͂ɐ؂ւiHi-Zj

																// DATArbg̓
    for(i = 0; i < 8; i++) {
        dat <<= 1;												// ̃rbg
        SCK_H();												// edge
        if(SHT_PORT & (1<<bitDATA)) {							// read DATA
																// "1"
            dat |= 1;
        }
        SCK_L();
    }

																// ACKrbg̏o
    if(!ack) {
        DATA_L();
    } else {
        DATA_H();
    }
    SCK_H();
    SCK_L();													// edge

    DATA_H();													// ͂ɐ؂ւiHi-Zj

    return dat;
}

//============================================================================
//	xZT[瓾xf[^A/DϊlMíjʂɐZŕϊB
//----------------------------------------------------------------------------
//	́F	
//	óF	xl10{l
//----------------------------------------------------------------------------
//	lF	x⏞܂܂Ȃ
//============================================================================
UH CalcHR10(void) {
    UH ad, x1, x2, x3, x4, cd10, b10;

																// Ƃ̐lo
    ad = ADValHR;
    x1 = ad / 1000;
    ad = ad - 1000 * x1;
    x2 = ad / 100;
    ad = ad - 100 * x2;
    x3 = ad / 10;
    x4 = ad - 10 * x3;

																// ƂA-Dl|Z
    x1 = ADValHR * x1;
    x2 = (ADValHR * x2 + 5) / 10;								// _ȉľܓ
    x3 = (ADValHR * x3 + 50) / 100;								// _ȉľܓ
    x4 = (ADValHR * x4 + 500) / 1000;							// _ȉľܓ

    x1 = x1 + x2 + x3 + x4;										// vZʂ
    x2 = (x1 + 5) / 10;											// 1/10. _ȉľܓ

    cd10 = (28 * x2 + 50) / 100;

    x1 = (ADValHR * 4 + 5) / 10;
    x2 = (ADValHR * 5 + 500) / 1000;
    b10 = x1 + x2;

    return -40 + b10 - cd10;									// xl10{l
}

//============================================================================
//	xZT[֓x̌vJn𑗐MAMmFɃf[^MBB
//----------------------------------------------------------------------------
//	́F	
//	óF	16rbgf[^ixA/Dϊlj
//----------------------------------------------------------------------------
//	lF	
//============================================================================
UH ShtCalGetRhum(void){
	UH	wdat;
	UB	bdat_H, bdat_L, bdat_CRC;

	SHTTSSeq();													//  TSV[PXs
	SHTWrite(0x05);												//  measure humidity R}hM

	while (SHT_PORT & (1<<bitDATA)) {}							//  A-Dϊ҂

	bdat_H = SHTRead(0);										//  read high byte(ack)
	bdat_L = SHTRead(0);										//  read Low byte(ack)
	bdat_CRC = SHTRead(1);										//  read CRC(NOack)

	wdat = ((UH)bdat_H << 8) | bdat_L;							//  translate to 16bits

	return	wdat;
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 Ohtan's Design Corporation